// Version 3  -  BLE-sender (central)  + Accelerator
// =========================

#include <ArduinoBLE.h>
#include "LSM6DS3.h"
#include "Wire.h"

//Create a instance of class LSM6DS3
LSM6DS3 myIMU(I2C_MODE, 0x6A);    //I2C device address 0x6A


uint8_t sendAsValue=0;
//int sendAsValue=0;

void setup() {
  Serial.begin(115200);
  pinMode(LED_BLUE, OUTPUT); // LED init
  digitalWrite(LED_BLUE, LOW);  //blue LED on

  //Call .begin() to configure the IMUs
  if (myIMU.begin() != 0) {
        Serial.println("Device error");
  } else {
        Serial.println("Device OK!");
  }
  // initialize the Bluetooth® Low Energy hardware
  BLE.begin();

  Serial.println("Bluetooth® Low Energy Central - control");

  // start scanning for peripherals
  BLE.scanForUuid("19b10000-e8f2-537e-4f6c-d104768a1214");
}

void loop() {
  // check if a peripheral has been discovered
  BLEDevice peripheral = BLE.available();
  //sendAsValue = sendAsValue + 1;

  if (peripheral) {
    // discovered a peripheral, print out address, local name, and advertised service
    Serial.print("Found ");
    Serial.print(peripheral.address());
    Serial.print(" '");
    Serial.print(peripheral.localName());
    Serial.print("' ");
    Serial.print(peripheral.advertisedServiceUuid());
    Serial.println();

    if (peripheral.localName() != "Arm") {
      return;
    }

    // stop scanning
    BLE.stopScan();
    sendValue(peripheral);
    
    // peripheral disconnected, start scanning again
    BLE.scanForUuid("19b10000-e8f2-537e-4f6c-d104768a1214");
  }
}

void sendValue(BLEDevice peripheral) {
  // connect to the peripheral
  Serial.println("Connecting ...");

  if (peripheral.connect()) {
    Serial.println("Connected");
  } else {
    Serial.println("Failed to connect!");
    digitalWrite(LED_GREEN, HIGH);
    return;
  }

  // discover peripheral attributes
  Serial.println("Discovering attributes ...");
  if (peripheral.discoverAttributes()) {
    Serial.println("Attributes discovered");
  } else {
    Serial.println("Attribute discovery failed!");
    peripheral.disconnect();
    digitalWrite(LED_GREEN, HIGH);
    return;
  }

  // retrieve the LED characteristic
  BLECharacteristic valueCharacteristic = peripheral.characteristic("19b10001-e8f2-537e-4f6c-d104768a1214");
/*
  if (!valueCharacteristic) {
    Serial.println("Peripheral does not have right characteristic!");
    peripheral.disconnect();
    return;
  } else if (!valueCharacteristic.canWrite()) {
    Serial.println("Peripheral does not have a writable characteristic!");
    peripheral.disconnect();
    return;
  }
*/
  while (peripheral.connected()) {
    // while the peripheral is connected
        //valueCharacteristic.writeValue((byte)0x01);
        //sendAsValue = random(0,255);
        digitalWrite(LED_BLUE, HIGH); //blue LED on
        digitalWrite(LED_GREEN, LOW); //green LED on
        float value = myIMU.readFloatAccelY(); delay(10);
        //valueCharacteristic.writeValue(sendAsValue);
        //Serial.print("sent: "); Serial.println(sendAsValue);
        
        value = value * 100;
        sendAsValue = map(value, -100, 100, 180,0);
        valueCharacteristic.writeValue(sendAsValue);
        Serial.print("sent: "); Serial.println(sendAsValue);
    }

  //Serial.println("Peripheral disconnected");
  digitalWrite(LED_GREEN, HIGH);
  digitalWrite(LED_BLUE, LOW);
}
